<template>
  <a-modal
    :title="modalTitle"
    :width="640"
    :visible="visible"
    :confirmLoading="confirmLoading"
    @cancel="handleCancel"
  >
    <a-form :form="form">
      <a-form-item
        label="上传文件"
        :labelCol="BaseTool.Constant.labelCol"
        :wrapperCol="BaseTool.Constant.wrapperCol"
      >
        <a-upload :fileList="fileList" @change="handleChange" :remove="handleRemove" :beforeUpload="beforeUpload">
          <a-button> <a-icon type="upload" />选择上传文件</a-button>
        </a-upload>
      </a-form-item>
    </a-form>
    <p style="color: red">注意事项：<br/>
      1：请确保设备新号、名称、型号的准确填写<br/>
      2：请确保文件从系统中导出，并未修改格式，重新导入成功的数据将覆盖原有数据的属性<br/>
      3：导入如出现问题，请及时联系<br/>
    </p>
    <template slot="footer">
      <a-button :loading="confirmLoading" type="primary" @click="save()">确定</a-button>
    </template>
  </a-modal>
</template>

<script>
import { importSbInfo } from '@/api/sb/info'

export default {
  name: 'SbModelBomImportForm',
  data () {
    return {
      confirmLoading: false,
      modalTitle: null,
      form: this.$form.createForm(this),
      visible: false,
      useCompany: null,
      useProject: null,
      type: null,
      fileList: []
    }
  },
  methods: {
    base (useCompany, useProject) {
      this.visible = true
      this.useCompany = useCompany
      this.useProject = useProject
      this.modalTitle = '设备修改导入'
      this.type = 2
    },
    handleRemove (file) {
      const index = this.fileList.indexOf(file)
      const newFileList = this.fileList.slice()
      newFileList.splice(index, 1)
      this.fileList = newFileList
    },
    beforeUpload (file) {
      const reg = /\.(xls|xlsx)(\?.*)?$/
      return new Promise((resolve, reject) => {
        if (reg.test(file.name)) {
          this.fileList = [file]
          return false
        } else {
          this.$message.error(`请上传正确的excel文件`)
          reject(new Error('请上传正确的excel文件'))
          return false
        }
      })
    },
    handleChange (info) {
      if (info.file.status !== 'uploading') {
        console.log(info.file, info.fileList)
      }
      if (info.file.status === 'done') {
        this.$message.success(`${info.file.name} file uploaded successfully`)
      } else if (info.file.status === 'error') {
        this.$message.error(`${info.file.name} file upload failed.`)
      }
    },
    save () {
      const { form: { validateFieldsAndScroll } } = this
      this.confirmLoading = true
      validateFieldsAndScroll((errors, values) => {
        if (errors) {
          this.confirmLoading = false
          return
        }
        const formData = new FormData()
        formData.append('type', this.type)
        formData.append('file', this.fileList[0])
        importSbInfo(formData)
          .then((res) => {
            this.$message.success(res.data)
            this.handleCancel(values)
            this.BaseTool.ListForm.clearOneList(this)
            this.BaseTool.ListForm.pushOneListAddMore(this, res.data)
          }).catch(() => {
            this.confirmLoading = false
          })
      })
    },
    handleCancel (values) {
      this.visible = false
      this.confirmLoading = false
      this.fileList = []
      this.form.resetFields()
      this.storeId = null
      this.$emit('ok', values)
    }

  }
}
</script>
